/*  B1FF.c (6)	B1FF-iser filter
 * 		Kibozed up on 4-2-1993 by acb
 *		(K) All rites reversed.
 *
 *		If you like this program, either
 *		send me $20, or partake joyously of
 *		a hot dog bun... -><-
 *
 *  Command-line options:
 *		(note: --x turns off -x)
 *
 *		-bn	Convert ! to n !s
 *		-k 	Convert words starting with C to start with K
 *		-K 	Convert all Cs to Ks
 *		-L	Convert Ks to ]<s
 *		-vn  	n columns/screen (default = 22); 0 turns off
 *		-0	Convert Os to 0s
 *		-1	Convert Is to 1s
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define BOOL int

#define FALSE 0
#define TRUE (!FALSE)

#define NUMCHARS 3
#define NUMSTRINGS 7

/* Default settings */

#define NUMEXCL 5		/* Number of !s to replace each ! with */
#define SCREENWIDTH 22		/* # of columns on a VIC-20 ! */

int iNumExcl=NUMEXCL;
int iScreenWidth=SCREENWIDTH;

/* Character translation constants */

#define CX_ZEROS 	0x0000
#define CX_ONES		0x0001
#define CX_C		0x0002

/* String translation constants */

#define SX_BIGK		0x0000
#define SX_INITIALC	0x0001

const char CharXlat[NUMCHARS*2] = "O0I1CK";

BOOL CharXlatPermissions[NUMCHARS] = {TRUE, TRUE, TRUE};

const char *StrXlat[NUMSTRINGS*2] = {"K", "]<", " C", " K", "S ", "Z ", "S!", "Z!", "S.", "Z.",
			"SOME", "SUM", "SAYS", "SEZ"};

BOOL StrXlatPermissions [NUMSTRINGS] = {TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE};

char XlatChar(char c) {
	int i;
	for(i=0; i<NUMCHARS; i++) {
		if((CharXlat[i*2]==c) && (CharXlatPermissions[i]))
			return CharXlat[i*2+1];
	};
	return c;
};

/* nputs(lpszOutput, n)	sends first n chars of lpszOutput to stdout and
 * removes them from lpszOutput.
 */

void nputs(char *lpszOutput, int n) {
	int i;
	for(i=0; i<min(strlen(lpszOutput), n); i++) {
		putc(lpszOutput[i], stdout);
	};
	if(n<strlen(lpszOutput)) {	/* remove that which has been printed */
		strcpy(lpszOutput, lpszOutput+n);
	} else {
		lpszOutput[0] = '\0';
	};
	putc('\n', stdout);
};

/* DoArgs() parses arguments */

void DoArgs(int argc, char *argv[]) {
	int i;
	for(i=1; i<argc; i++) {
		if(argv[i][0]=='-') {	/* a switch */
			char *lpszArg;
			BOOL fSetting;
			if (argv[i][1]=='-') {	/* turn something off */
				fSetting = FALSE;
				lpszArg = argv[i]+2;
			} else {	/* turn something on or get a value */
				fSetting = TRUE;
				lpszArg = argv[i]+1;
			};
			switch(*lpszArg) {
				case 'k': StrXlatPermissions[SX_INITIALC] = fSetting; break;
				case 'K': CharXlatPermissions[CX_C] = fSetting; break;
				case 'L': StrXlatPermissions[SX_BIGK] = fSetting; break;
				case '0': CharXlatPermissions[CX_ZEROS] = fSetting; break;
				case '1': CharXlatPermissions[CX_ONES] = fSetting; break;
				case 'b': iNumExcl = atoi(lpszArg+1); break;
				case 'v': iScreenWidth = atoi(lpszArg+1); break;
			};
		};
	};
};

void main(int argc, char *argv[]) {
	char szString[80], szNewString[127];
	DoArgs(argc, argv);			/* get switches, etc. */
	szNewString[0] = '\0';			/* initially empty */
	fgets(szString, 80, stdin);
	while(!feof(stdin)) {
		int i;
		BOOL fDone;
		for (i=0; i<strlen(szString); i++) {
			/* First, upper-case this character */
			szString[i] = toupper(szString[i]);
			/* Now, if the permission is set, change it */
			szString[i] = XlatChar(szString[i]);
		};
		/* Now, we change strings, if necessary  */
		szNewString[0] = '\0';
		for (i=0; i<strlen(szString); i++) {
			int j;
			fDone = FALSE;		/* No match found yet */
			for(j=0; j<NUMSTRINGS; j++) {
				if ((strncmp(szString+i, StrXlat[j*2],
				 strlen(StrXlat[j*2]))==0) &&
				 StrXlatPermissions[j]) {
					strcat(szNewString, StrXlat[j*2+1]);
					i += strlen(StrXlat[j*2])-1;
					fDone = TRUE;
				};
			};
			if (!fDone) {	/* No match, just copy char */
				strncat(szNewString, szString+i, 1);
			};
			/* handle !s */
			if (szString[i]=='!') {
				int j;
				for(j=0; j<iNumExcl-1; j++) {
					strcat(szNewString, "!");
				};
			};
		};
		/* Now, output it */
		while(strlen(szNewString)>0) {
			nputs(szNewString, iScreenWidth);
		};
		fgets(szString, 80, stdin);
	};
};
